/*
 *
 * ECE 474A/574A - Example C program for representing a graph.
 *                 Note: This is meant to be an illustrative example, and
 *                 does not adhere to good programming practices.
 *
 * Author: Roman Lysecky (this should be changed to your name before submitting)
 * Date: 01-12-2010
 *
 */

#include <stdlib.h>
#include <stdio.h>

#define MAX_VERTICES 10

typedef struct vertex_struct {
  int numEdges;
  int edges[MAX_VERTICES];
} vertex;

typedef struct dag_struct {
  int numVertices;
  vertex vertices[MAX_VERTICES];
} dag;

int main(int argc, char** argv) {
	
  dag myDag;
  char* buffer;
  int len;
  FILE* fp;
  int source, sink;
  int i, j;

  if( argc != 2 ) {
    printf("\nUsage: %s dagfile\n\n", argv[0]);
    return -1;
  }
  else {

    fp = fopen(argv[1], "r");

    if (fp == 0) {
      printf("\nCould not open file %s.\n\n", argv[1]);
      return -1;
    }

    myDag.numVertices = 0;
    if( fscanf(fp, "%i", &(myDag.numVertices)) == 1 ) {
      if( myDag.numVertices >= MAX_VERTICES || myDag.numVertices <= 0 ) {
	printf("\nError reading file %s. Too many vertices.\n\n", argv[1]);
	close(fp);
	return -1;
      }
    }
    else {
	printf("\nError reading file %s.\n\n", argv[1]);
	close(fp);
	return -1;
    }
    
    for(i=0; i<myDag.numVertices; i++) {
      myDag.vertices[i].numEdges = 0;
    }

    while( fscanf(fp, "%i %i", &source, &sink) != EOF ) {

      if( source >= MAX_VERTICES || source < 0 || sink >= MAX_VERTICES || sink < 0 ) {
	printf("\nError reading file %s. Invalid edge %i -> %i.\n\n", argv[1], source, sink);
	return -1;
	close(fp);
      }
      myDag.vertices[source].edges[myDag.vertices[source].numEdges] = sink; 
      myDag.vertices[source].numEdges++;
    }

    close(fp);

    printf("DAG = {\n");
    for(i=0; i<myDag.numVertices; i++) {
      printf("        %i: ", i);
      for(j=0; j<myDag.vertices[i].numEdges; j++) {
	printf("%i ", myDag.vertices[i].edges[j]);
      }
      printf("\n");
    }
    printf("}\n");
  }

  return 0;
}


